#!/usr/local/bin/itkwish3.0
# Program: TFP_drugrefill
# Tcl version: 8.0 (Tcl/Tk)
# Tk version: 8.0
#


if {$tcl_platform(os) == "Linux"} {
    # this was if a user installed it in his home directory, I have only
    # run it as root so it needs to be tested more

    package require Iwidgets 3.0
    cd ~
    set rootdirectory [eval pwd]
  
# this is specific to my system as I ran out of disk space on my 486 and the progress
# note files to the TFP3 machine.

# catch {exec mount -t nfs "TFP3:/root/progress_notes" $rootdirectory/progress_notes}

    cd $rootdirectory/drug_programs
    if { $rootdirectory == "/root" } {
         set tempfaxdirectory /var/local/bin
        } else {
                set tempfaxdirectory "$rootdirectory/efax08a"
               }
# uncomment the next 3 lines if you want to try out the socket based physician/pharmacy drug
# refill programs ...
#    exec Echo_Server_ViewPatient &
#    exec Echo_Server_ViewRefill &
#    exec Echo_Server_Refill &
    
     
   } else {
     # this is if it's running on Windows which I assume is the only other
     # platform. If you try the Mac, you could change to an elseif
     # statement for Windows with the tclplatform(os) read for Windows or
     # then a final else statement for other OS's which would leave MAC by
     #  default. 
     # I've never run it on a MAC but if you could find a fax program
     #  there's no theoretical reason it couln't work.

     package require widgets++
     set rootdirectory "c:/program files/tcl/bin"
     set tempfaxdirectory "c:/bgfax"
    
     
     # this a a critical step on Windows, it enables the send command
     # under Tcl/Tk 8.0 This dynamically loads a needed library.
     # The newest version of 
     # Tcl/Tk 8.1, is supposed to include the send command for Windows
     # but the tcl++ widgets don't seem to work on Tcl/Tk 8.1 yet.

     #load dde

     #currently I'm trying the comm library which is like send but uses sockets instead of DDE
     cd $rootdirectory/drug_programs
     source  comm.tcl

     # uncomment this to start an experimental socket based client-server drugrefill module
     #exec "c:/progra~1/tcl/bin/drug_programs/server.bat" &
     
}

option readfile $rootdirectory/drug_programs/tkoptions
source $rootdirectory/drug_programs/balloonhelp.tcl




# experimental to load the html rendering library from spynergy and
# the http url downloading procedures from it as well
source $rootdirectory/drug_programs/spynergy.tcl





# procedure to show window .

proc ShowWindow. {args} {
  # xf ignore me 7

  # Window manager configurations
  wm positionfrom . user
  wm geometry . +194+2
  wm sizefrom . ""
  wm maxsize . 1009 1000
  wm minsize . 1 1

  wm title . {TFP Medical Information System}
# we are inside a procedure so these have to be declared global
# but the textvariables created in here are global automatically apparantly
global nameentry
global rootdirectory
global tempfaxdirectory
global maxdialattempts
global tcl_platform

# these variables will be set by the commserver.tcl program after all the
# programs start up, commserver.tcl will read their process id's and send them
# to all the programs so communication can be set up by the comm send command

global browsename.tcl
global browsedrug.tcl
global demographicform.tcl
global note_gen.tcl

  # build widget .topframe
  frame .topframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.topleftframe
  frame .topframe.topleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.topleftframe.topleftleftframe
  frame .topframe.topleftframe.topleftleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.topleftframe.topleftleftframe.namelabel
  label .topframe.topleftframe.topleftleftframe.namelabel \
    -relief {groove} \
    -text {enter name here}

  set nameentry ".topframe.topleftframe.topleftleftframe.nameentry"
  entry .topframe.topleftframe.topleftleftframe.nameentry \
    -textvariable {name}
  balloonhelp .topframe.topleftframe.topleftleftframe.nameentry "The name in this box will be faxed to the drugstore. 
Use the format Lastname_Firstname. The underscore character
is required.  You can add a birthdate or other
distinguishing characters to the end to
avoid duplication with another patient with 
same name. You can use parentheses but don't use
a \/ or quote characters which have  special meaning to the 
Tcl/Tk interpreter. Don't leave any spaces in the name.
The name loads automatically when selected
from the name entry listbox or if it is a 
new patient, you type it in here once and 
the patient will be added to the system. New 
files are created for demographics, allergies,
problem list, drug refills and progress notes 
at the same time, for the new patient, even if 
not used right away."

if {$tcl_platform(os) == "Linux"} {
bind .topframe.topleftframe.topleftleftframe.nameentry <Key-Return>  {send browsedrug.tcl "set name $name"}
} else {
bind .topframe.topleftframe.topleftleftframe.nameentry <Key-Return>  {comm send ${browsedrug.tcl} "set name $name"} 
}
 # build widget .topframe.topleftframe.topleftleftframe.clearbutton
  button .topframe.topleftframe.topleftleftframe.clearbutton \
    -command {set name "";pack .topframe.topleftframe.topleftleftframe.nameentry;$nameentry configure -fg black -bg gray;bell 
} \
    -padx {9} \
    -pady {3} \
    -text {Clear Name Entry Box}

  # build widget .topframe.topleftframe.topleftleftframe.printbutton
  button .topframe.topleftframe.topleftleftframe.printbutton \
     -command {if {$tcl_platform(os) == "Linux" } {
      exec /usr/bin/pr -t  $rootdirectory/drug_refills/$name | lpr -P ascii &
      } elseif  { $rootdirectory == "c:/progra~1/tcl/bin" } {
      exec c:/progra~1/access~1/wordpad.exe /P $rootdirectory/drug_refills/$name &
      }
} \
    -padx {9} \
    -pady {3} \
    -text {Print Patient's Refill File}

  button .topframe.topleftframe.topleftleftframe.allergybutton \
 -text "Check/Edit Allergies" -command  { if [file isfile $rootdirectory/allergies/$name ] {toplevel .allergy ;text .allergy.text -wrap word -yscrollcommand ".allergy.scroll set"
        ;pack .allergy.text -side left -expand true -fill both;
        scrollbar .allergy.scroll -command ".allergy.text yview"
        ;wm title .allergy "$name - Allergies"
        ;pack .allergy.scroll -side left -fill y;loadFileEdit $rootdirectory/allergies/$name .allergy.text
        ;button .allergy.save -command {writeFileEdit $rootdirectory/allergies/$name .allergy.text;bell} -text Save
        ;pack .allergy.save -side bottom -fill x 
         ;button .allergy.delete -bg red -fg yellow -text "Del. File" -command {toplevel .allergysure
         ;label .allergysure.question -text "Sure?"
         ;button .allergysure.yes  -command "file delete $rootdirectory/allergies/$name;destroy .allergysure;destroy .t;bell" -text Yes;
         ;button .allergysure.no -command "destroy .allergysure" -text No;pack .allergysure.question .allergysure.yes .allergysure.no};
         pack .allergy.delete -side bottom -anchor sw -fill x; button .allergy.exit -fg red -bg yellow -text Exit -command {destroy .allergy;bell};
         pack .allergy.exit -side top -fill x}  else {toplevel .allergyerror;label .allergyerror.label -text "Sorry,
         no allergies for $name...";button .allergyerror.ok -text OK -command {destroy .allergyerror};pack .allergyerror.label .allergyerror.ok }
        }

balloonhelp .topframe.topleftframe.topleftleftframe.allergybutton "Press here to edit the\n allergy file for the \n currently selected patient. \ 
Can be used to add or remove\n allergies to allergy file." 



balloonhelp .topframe.topleftframe.topleftleftframe.printbutton "Send Patient's Refill To Printer"

  # build widget .topframe.topleftframe.topleftrightframe
  frame .topframe.topleftframe.topleftrightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.topleftframe.topleftrightframe.medicinelabel
  label .topframe.topleftframe.topleftrightframe.medicinelabel \
    -relief {groove} \
    -text {enter medicine here}

  # build widget .topframe.topleftframe.topleftrightframe.medicineentry
  entry .topframe.topleftframe.topleftrightframe.medicineentry \
    -textvariable {medicine}

balloonhelp .topframe.topleftframe.topleftrightframe.medicineentry "The medicine to be faxed the the pharmacy 
gets loaded here when the selected medicine is 
double clicked from the either the drugbrowser listbox 
on  the lower left of the display.  I used all lower case 
letters in most cases for the name of the drugs but you
don't have to. It is important to not have an upper and 
lower case entry for the same medicine, however as the 
computer will then think these are two seperate medications.
Also, don't leave any spaces in the name. Connect the words
with an underscore _ character. This is because the scanning
functions for finding the drug name in the refill file for 
several procedures will not recognize the drug correctly 
otherwise. An example is darvocet_N_100. Don't use a dash 
like this darvocet-N-100. This is because the word recognition
function in the text widget thinks the dash marks the end of
the word and the scanning funtions will fail."

  # build widget .topframe.topleftframe.topleftrightframe.clearbutton
  button .topframe.topleftframe.topleftrightframe.clearbutton \
    -command {set medicine "";pack .topframe.topleftframe.topleftrightframe.medicineentry;bell
} \
    -padx {9} \
    -pady {3} \
    -text {Clear Medicine Entry Box}


  # build widget .topframe.topleftframe.topleftrightframe.editfilebutton
  button .topframe.topleftframe.topleftrightframe.editfilebutton \
        -command { if {$tcl_platform(os) == "Linux" } {
                   exec xedit $rootdirectory/drug_refills/$name &;bell
                  } elseif { $rootdirectory == "c:/progra~1/tcl/bin" } {
                   $rootdirectory == "c:/progra~1/tcl/bin/"
                    exec c:/progra~1/access~1/wordpad.exe $rootdirectory/drug_refills/$name &
                  }
} \
    -padx {9} \
    -pady {3} \
    -text {Edit Patient's Refill File}

balloonhelp .topframe.topleftframe.topleftrightframe.editfilebutton "Allows you to\n correct mistakes 
in Patient\'s refill file. Alternatively, 
you can directly edit the text in the right
hand window and press the green button on the
bottom row of buttons to save the changes 
permanently."

button .topframe.topleftframe.topleftrightframe.interactionbutton \
 -text "Check/Edit Interactions" -command  { if [file isfile $rootdirectory/drug_interactions/$medicine ] {toplevel .interact ;text .interact.text -wrap word -yscrollcommand ".interact.scroll set";pack .interact.text -side left -expand true -fill both;
        scrollbar .interact.scroll -command ".interact.text yview"
        ;wm title .interact "$medicine - Interactions"
        ;pack .interact.scroll -side left -fill y;loadFileEdit $rootdirectory/drug_interactions/$medicine .interact.text
        ;button .interact.save -command {writeFileEdit $rootdirectory/drug_interactions/$medicine .interact.text;bell} -text Save
        ;pack .interact.save -side bottom -fill x
         ;button .interact.delete -bg red -fg yellow -text "Del. File" -command {toplevel .interactsure
         ;label .interactsure.question -text "Sure?"
         ;button .interactsure.yes  -command "file delete $rootdirectory/drug_interactions/$medicine;destroy .interactsure;destroy .interact;bell" -text Yes;
         ;button .interactsure.no -command "destroy .interactsure" -text No;pack .interactsure.question .interactsure.yes .interactsure.no};
         pack .interact.delete -side bottom -anchor sw -fill x; button .interact.exit -fg red -bg yellow -text Exit -command {destroy .interact;bell};
         pack .interact.exit -side top -fill x}  else {toplevel .interacterror;label .interacterror.label -text "Sorry,
         no interactions for $medicine...";button .interacterror.ok -text OK -command {destroy .interacterror};pack .interacterror.label .interacterror.ok }
        }

balloonhelp .topframe.topleftframe.topleftrightframe.interactionbutton "Press here to edit the\n drug interaction file for the \n currently selected drug. \
Can be used to add or remove\n interactions to the drug's file."
    


  # build widget .topframe.toprightframe
  frame .topframe.toprightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.toprightframe.toprightleftframe
  frame .topframe.toprightframe.toprightleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.toprightframe.toprightleftframe.doselabel
  label .topframe.toprightframe.toprightleftframe.doselabel \
    -relief {groove} \
    -text {enter dose here}

  # build widget .topframe.toprightframe.toprightleftframe.doseentry
  entry .topframe.toprightframe.toprightleftframe.doseentry \
    -textvariable {dose}
balloonhelp .topframe.toprightframe.toprightleftframe.doseentry "The dose for the selected medication to be faxed gets 
entered here. If you double left click on
the medication from the list box on the lower 
left, the pop-up dose menu will be loaded with the 
doses for the selected medication from the dose 
file for that medication. There can be no spaces 
in the dose entry but you can use most other 
characters except  a \/ or quotes or a \'."


  # build widget .topframe.toprightframe.toprightleftframe.clearbutton
  button .topframe.toprightframe.toprightleftframe.clearbutton \
    -command {set dose "";pack .topframe.toprightframe.toprightleftframe.doseentry;bell
} \
    -padx {9} \
    -pady {3} \
    -text {Clear Dose Entry Box}
    
  # build widget .topframe.toprightframe.toprightleftframe.button0
  button .topframe.toprightframe.toprightleftframe.button0 \
    -command {exec $rootdirectory/drug_programs/browsename.tcl &
} \
    -padx {9} \
    -pady {3} \
    -text {Patient Name Browser}

balloonhelp .topframe.toprightframe.toprightleftframe.button0 "Refresh the Name \ Browser\n if new names have been added.\n Be sure to kill the old one first!"

  menubutton .topframe.toprightframe.toprightleftframe.dosemenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Select Dose} \
      -menu .topframe.toprightframe.toprightleftframe.dosemenubutton.m -indicatoron 1
      bind .topframe.toprightframe.toprightleftframe.dosemenubutton <Button-3> {editFile $rootdirectory/drug_doses/$medicine}
   
   balloonhelp .topframe.toprightframe.toprightleftframe.dosemenubutton "Left click here to select acceptable doses 
for the current medicine. New doses 
added to the dose file for the selected
drug will not show up until the program is
restarted at the present time. I will be 
changing this in future versions of the 
program. Right click to edit the doses for
the currently selected medicine. New entries
again don't show up until you reload the 
medication from the medicine browser."

   menu .topframe.toprightframe.toprightleftframe.dosemenubutton.m






if {$tcl_platform(os) == "Linux"} {
  button .topframe.toprightframe.toprightleftframe.druginformationbutton \
 -text "Check Drug Info." -command  { if {[file isfile $rootdirectory/drug_information/$medicine.cfm] } \
        {toplevel .tinfo ;iwidgets::scrolledhtml .tinfo.druginfo -labeltext "Drug Information $medicine" \
      -width 5i -height 4i \
      -wrap word -linkcommand ".tinfo.druginfo  import -link" -state normal -padx 10
      pack .tinfo.druginfo -side left -expand true -fill both;
   
      catch {.tinfo.druginfo import $rootdirectory/drug_information/$medicine.cfm}
        ;button .tinfo.save -command {writeFileEdit $rootdirectory/drug_information/$medicine .tinfo.text;bell} -text Save
        ;pack .tinfo.save -side bottom -fill x
        
          ;button .tinfo.print  -text "Print Info." -command {if {$tcl_platform(os) == "Linux" } {
          exec netscape $rootdirectory/drug_information/$medicine.cfm &
          } else {
          exec c:/progra~1/Netscape/Communicator/Program/netscape.exe $rootdirectory/drug_information/$medicine.cfm &
          }
         }
       
         ;button .tinfo.delete -bg red -fg yellow -text "Del. File" -command {toplevel .sure
         ;label .sure.question -text "Sure?"
         ;button .sure.yes  -command "file delete $rootdirectory/drug_information/$medicine;destroy .sure;destroy .tinfo;bell" -text Yes;
         ;button .sure.no -command "destroy .sure" -text No;pack .sure.question .sure.yes .sure.no};
         pack .tinfo.delete -side bottom -anchor sw -fill x; button .tinfo.exit -fg red -bg yellow -text exit -command {destroy  .tinfo;bell};
         pack .tinfo.exit -fill x;pack .tinfo.print -side bottom -fill x;
         } elseif {
         ![file isfile $rootdirectory/drug_information/$medicine.cfm] && [winfo exists .tinfo]} {toplevel .error;label .error.label -text "Sorry,
         no information for $medicine...";button .error.ok -text OK -command {destroy .error};pack .error.label .error.ok
         }  else {
         toplevel .error;label .error.label -text "Sorry,
         no information for $medicine...";button .error.ok -text OK -command {destroy .error};pack .error.label .error.ok }
        }
} else {
 button .topframe.toprightframe.toprightleftframe.druginformationbutton \
 -text "Check Drug Info." -command  { if {[file isfile $rootdirectory/drug_information/$medicine.cfm] } \
        {toplevel .tinfo ;scrolledhtml .tinfo.druginfo -labeltext "Drug Information $medicine" \
      -width 5i -height 4i \
      -wrap word -linkcommand ".tinfo.druginfo  import -link" -state normal -padx 10
      pack .tinfo.druginfo -side left -expand true -fill both;
      catch {.tinfo.druginfo import $rootdirectory/drug_information/$medicine.cfm}
        ;button .tinfo.save -command {writeFileEdit $rootdirectory/drug_information/$medicine .tinfo.text;bell} -text Save
        ;pack .tinfo.save -side bottom -fill x
        
          ;button .tinfo.print  -text "Print Info." -command {if {$tcl_platform(os) == "Linux" } {
          exec netscape $rootdirectory/drug_information/$medicine.cfm &
          } else {
          exec c:/Progra~1/Netscape/Communicator/Program/netscape.exe $rootdirectory/drug_information/$medicine.cfm &
          }
         }
       
         ;button .tinfo.delete -bg red -fg yellow -text "Del. File" -command {toplevel .sure
         ;label .sure.question -text "Sure?"
         ;button .sure.yes  -command "file delete $rootdirectory/drug_information/$medicine;destroy .sure;destroy .tinfo;bell" -text Yes;
         ;button .sure.no -command "destroy .sure" -text No;pack .sure.question .sure.yes .sure.no};
         pack .tinfo.delete -side bottom -anchor sw -fill x; button .tinfo.exit -fg red -bg yellow -text exit -command {destroy  .tinfo;bell};
         pack .tinfo.exit -fill x;pack .tinfo.print -side bottom -fill x;
         } elseif {
         ![file isfile $rootdirectory/drug_information/$medicine.cfm] && [winfo exists .tinfo]} {toplevel .error;label .error.label -text "Sorry,
         no information for $medicine...";button .error.ok -text OK -command {destroy .error};pack .error.label .error.ok
         }  else {
         toplevel .error;label .error.label -text "Sorry,
         no information for $medicine...";button .error.ok -text OK -command {destroy .error};pack .error.label .error.ok }
        }
}
balloonhelp .topframe.toprightframe.toprightleftframe.druginformationbutton "Press here to check the\n information file for the \n currently selected drug. \
Can be used to add or remove\n information to information file."


  # build widget .topframe.toprightframe.toprightrightframe
  frame .topframe.toprightframe.toprightrightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topframe.toprightframe.toprightrightframe.quantitylabel
  label .topframe.toprightframe.toprightrightframe.quantitylabel \
    -relief {groove} \
    -text {enter quantity here}

  # build widget .topframe.toprightframe.toprightrightframe.quantityentry
#  entry .topframe.toprightframe.toprightrightframe.quantityentry \
#    -textvariable {quantity}
if {$tcl_platform(os) == "Linux"} {
     iwidgets::spinner .topframe.toprightframe.toprightrightframe.quantityentry \
     -textvariable {quantity} \
      -decrement {spinMonth .topframe.toprightframe.toprightrightframe.quantityentry -10} \
      -increment {spinMonth .topframe.toprightframe.toprightrightframe.quantityentry  1}
     } else {
spinner .topframe.toprightframe.toprightrightframe.quantityentry \
     -textvariable {quantity} \
      -decrement {spinMonth .topframe.toprightframe.toprightrightframe.quantityentry -10} \
      -increment {spinMonth .topframe.toprightframe.toprightrightframe.quantityentry  1}
     }
  # build widget .topframe.toprightframe.toprightrightframe.clearbutton
  button .topframe.toprightframe.toprightrightframe.clearbutton \
    -command {set quantity "";pack .topframe.toprightframe.toprightrightframe.quantityentry;bell
} \
    -padx {9} \
    -pady {3} \
    -text {Clear Quant. Entry Box}

  global c
  global refills
  set c .topframe.toprightframe.toprightrightframe
  
  menubutton $c.refillmenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Add No. Refills} \
      -menu $c.refillmenubutton.m -indicatoron 1

   balloonhelp $c.refillmenubutton "Press here to add the no. of refills\n No. will be appended to the\n message above."
      
   menu $c.refillmenubutton.m


  # build widget .topframe.toprightframe.toprightrightframe.problemlistbutton
  frame .topframe.toprightframe.toprightrightframe.problabframe
 button  .topframe.toprightframe.toprightrightframe.problabframe.problemlistbutton -text {Problems} \
    -command {if [file isfile $rootdirectory/problem_list/$name] {toplevel .t5 ;text .t5.text  -width 80 -height 25 -wrap word -yscrollcommand ".t5.scroll set"
        ;pack .t5.text -side left -fill both -expand true
        ;scrollbar .t5.scroll -command ".t5.text yview"
        ;wm title .t5 "Problem List - $name"
        ;pack .t5.scroll -side left -fill y;loadFileEdit $rootdirectory/problem_list/$name .t5.text
        ;button .t5.save -command {writeFileEdit $rootdirectory/problem_list/$name .t5.text;bell} -text Save
        ;pack .t5.save -side bottom -fill x
        foreach item [list {Problems} {Past Medical Illnesses} {Past Surgeries} {Family History} {Social History} {Immunizations} {Significant past procedures}] {
        forAllMatches .t5.text $item {.t5.text tag add big first last}
        }
        .t5.text tag configure big -background blue -foreground yellow -font -Adobe-Helvetica-medium-R-Normal--*-140-* 
        .t5.text yview 1.0
        ; button .t5.delete -bg red -fg yellow -text "Del. File" -command {file delete $rootdirectory/problem_list/$name }
        ;pack .t5.delete -side bottom -anchor sw -fill x
        ;button .t5.exit -fg red -bg yellow -text Exit -command {destroy .t5}
        ;pack .t5.exit -side top -fill x
        ;button .t5.center -text <CENTER> -command {set bingo [.t5.text tag ranges sel];.t5.text insert [lindex $bingo 1] "</CENTER>";.t5.text insert [lindex $bingo 0] "<CENTER>"}
        ;pack .t5.center -side top -fill x
        ;button .t5.paragraph -text <P> -command {.t5.text insert insert <P>}
        ;pack .t5.paragraph -side top -fill x
        ;button .t5.break -text <BR> -command {.t5.text insert insert <BR>}
        ;pack .t5.break -side top -fill x
        ;button .t5.ul -text <UL> -command {.t5.text insert insert <UL>}
        ;pack .t5.ul -side top -fill x
        ;button .t5.li -text <LI> -command {.t5.text insert insert <LI>}
        ;pack .t5.li -side top -fill x
        ;button .t5.anchor -text <A> -command {set bang [.t5.text tag ranges sel];.t5.text insert [lindex $bang 1] "</A>";.t5.text insert [lindex $bang 0] "<A href=\"\">"}
        ;pack .t5.anchor -side top -fill x
        ;button .t5.pre -text <PRE> -command {set nono [.t5.text tag ranges sel];.t5.text insert [lindex $nono 1] "</PRE>";.t5.text insert [lindex $nono 0] "<PRE>"}
        ;pack .t5.pre -side top -fill x
         } else {toplevel .problemlisterror;label .problemlisterror.label -text "Sorry,
         no problem list for $name...";button .problemlisterror.ok -text OK -command {destroy .problemlisterror};pack .problemlisterror.label .problemlisterror.ok }

}
    

balloonhelp .topframe.toprightframe.toprightrightframe.problabframe.problemlistbutton "View or edit the currently selected patient's
problem list file. In here you can store problem
list, past medical history, past surgeries, immunizations,
social history etc. Anything in this file can be inserted
into the progress notes by the progress note generator
module."

button .topframe.toprightframe.toprightrightframe.problabframe.vitalsignbutton -text "Vitals" -command {
        if {$tcl_platform(os) == "Linux"} {
           exec $rootdirectory/drug_programs/BloodPressurePlot $name &
        } else {
           exec wish80 $rootdirectory/drug_programs/BloodPressurePlot $name &
        }
        }

button .topframe.toprightframe.toprightrightframe.problabframe.labresults -text "Labs" -command checkLabResults



  # build widget .middleframe
  frame .middleframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .middleframe.middleleftframe
  frame .middleframe.middleleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .middleframe.middleleftframe.middleleftleftframe
  frame .middleframe.middleleftframe.middleleftleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .middleframe.middleleftframe.middleleftleftframe.drugstorelabel
  label .middleframe.middleleftframe.middleleftleftframe.drugstorelabel \
    -relief {groove} \
    -text {Drugstore Selection}
  global d
  set d .middleframe.middleleftframe.middleleftleftframe
  entry $d.drugstoreentry -textvariable drugstore
  menubutton $d.drugstoremenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Select Drugstore} \
      -menu $d.drugstoremenubutton.m -indicatoron 1 
balloonhelp $d.drugstoremenubutton "Press here to select drugstore
to fax the current data to
or to select the temp fax
file to edit."      
  bind $d.drugstoremenubutton <Button-3> {editFile $rootdirectory/drug_programs/drugstorelist}
   menu $d.drugstoremenubutton.m
    
# make a button for editing the currently selected drugstore so you can correct a mistake before the file is faxed.

button $d.faxeditbutton  -text "Edit Fax Files" -command  { if [file isfile $tempfaxdirectory/$drugstore ] {
        editFile $tempfaxdirectory/$drugstore
        } else {toplevel .error;label .error.label -text "Sorry, no faxes for $drugstore...";button .error.ok -text OK -command {destroy .error};pack .error.label .error.ok }
        }

balloonhelp $d.faxeditbutton "Press here to edit the
temporary fax file for the
currently selected drugstore.  
Can be used to add comments
or other text to fax message 
or to correct mistakes that
may have gotten into the
temporary  fax file for the
selected drugstore." 


#make a button for editing the drugstore fax number file



  # build widget .middleframe.middleleftframe.middleleftrightframe
  global e
  frame .middleframe.middleleftframe.middleleftrightframe \
    -borderwidth {2} \
    -relief {raised}
  set e .middleframe.middleleftframe.middleleftrightframe
  # build widget .middleframe.middleleftframe.middleleftrightframe.doctorlabel
  label .middleframe.middleleftframe.middleleftrightframe.doctorlabel \
    -relief {groove} \
    -text {select doctor}

  entry $e.doctorentry -textvariable initial




    
  menubutton $e.doctormenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Select Doctor} \
      -menu $e.doctormenubutton.m -indicatoron 1
  balloonhelp $e.doctormenubutton "Press here to select doctor"
  bind $e.doctormenubutton <Button-3> {editFile $rootdirectory/drug_programs/doctorlist}
   menu $e.doctormenubutton.m
balloonhelp $e.doctormenubutton "Left click this to change the 
current doctor for the refill
messages. Right click to bring
up a toplevel window you can 
use to edit the doctor list - 
handy in today's rapid turnover
HMO environment!"    

# make an entry to store and enter the no. of dialattempts allowed this keeps it
# the test3.tcl procedure from going into an endless loop. Variable is passed to
# test3.tcl as an argument.

label $e.dialattemptslabel -text "no. Dial Attempts"
entry $e.dialattemptsentry -width 3 -textvariable maxdialattempts

balloonhelp $e.dialattemptsentry "Sets the max. no. of \n dial attempts the fax 
program is allowed to \n avoid an endless loop 
in case of a problem faxing."



  # build widget .middleframe.middlerightframe
  frame .middleframe.middlerightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .middleframe.middlerightframe.middlerightleftframe
  frame .middleframe.middlerightframe.middlerightleftframe \
    -borderwidth {2} \
    -relief {raised}

  global h
  set h .middleframe.middlerightframe.middlerightleftframe
  # build widget .middleframe.middlerightframe.middlerightleftframe.yournamelabel

  label .middleframe.middlerightframe.middlerightleftframe.yournamelabel \
    -relief {groove} \
    -text {select your name}
   
  entry $h.employeeentry -textvariable yourname

    menubutton $h.employeemenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Select Employee} \
      -menu $h.employeemenubutton.m -indicatoron 1
    bind $h.employeemenubutton <Button-3> {editFile $rootdirectory/drug_programs/employeelist}
  balloonhelp $h.employeemenubutton "Left click here to select employee name
that will be included in the fax
messages.  Right click to bring up
a toplevel window you can use to add
or remove employees - also handy in 
today's rapid turnover HMO environment!"
   menu $h.employeemenubutton.m

  

  button $h.statistics -text "Check Statistics" -command statistics


  # build widget .middleframe.middlerightframe.middlerightrightframe
  frame .middleframe.middlerightframe.middlerightrightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .middleframe.middlerightframe.middlerightrightframe.notelabel
  label .middleframe.middlerightframe.middlerightrightframe.notelabel \
    -relief {groove} \
    -text {select message to send}
  global i
  set i .middleframe.middlerightframe.middlerightrightframe
  
  entry $i.noteentry -textvariable note
         
    menubutton $i.notemenubutton -background peachpuff \
      -foreground  steelblue -relief raised -text {Select Note to Send} \
      -menu $i.notemenubutton.m -indicatoron 1
    bind $i.notemenubutton <Button-3> {editFile $rootdirectory/drug_programs/messagelist}

  balloonhelp $i.notemenubutton "Left click here to bring up
menu from which you can select 
the refill message to send with
each drug. Defaults to \"refill
OK per Doctor\". Right click to 
add more phrases to the menu that
you can customize. Or you can re-
move phrases you don't use."
   menu $i.notemenubutton.m




  button .middleframe.middlerightframe.middlerightrightframe.checkrefillbutton \
     -command {loadFileRefill $rootdirectory/drug_programs/refill_requests
} \
     -text {Check Refill Requests}
balloonhelp .middleframe.middlerightframe.middlerightrightframe.checkrefillbutton "Causes left text widget \n to display the refill \
requests submitted by the \n pharmacies. You can click on \n blue text to respond."

#text .text2 -relief groove -wrap word -width 48 -height 24 \
#    -yscrollcommand ".scroll2 set"
#scrollbar .scroll2 -command ".text2 yview"

frame .statusframe -height 4 -width 20
label .statuslabel -text "Fax Status Messages" -relief groove

text .text3 -relief sunken -wrap word -width 21 -height 5 -bg peachpuff \
   -yscrollcommand ".scroll3 set"

scrollbar .scroll3 -command ".text3 yview"
# procedure to check the dose of a medicine and make sure its an approved
# dose for that medication if not a warning box appears on the screen

proc checkdose {} {

global medicine
global dose
global rootdirectory

set f [open $rootdirectory/drug_doses/$medicine r]
while {[gets $f line] >=0} {
   if [regexp $dose $line] {
   return 0 }
   }
   close $f
   toplevel .t2 
   
   button .t2.dosewarning -fg yellow -bg red -text {Warning! dose does not match accepted range...}
   pack .t2.dosewarning;wm title .t2 $medicine  
   button .t2.ok -fg steelblue -bg peachpuff -text IGNORE -command {destroy .t2;bell}
   pack .t2.ok -side bottom
   button .t2.edit -fg steelblue -bg peachpuff -text {VIEW/EDIT doses} \
     -command {destroy .t2;bell;toplevel .t ;text .t.text  -wrap word -yscrollcommand ".t.scroll set";pack .t.text -side left;
      scrollbar .t.scroll -command ".t.text yview"
      ;wm title .t $medicine
      ;pack .t.scroll -side left -fill y;loadFileEdit $rootdirectory/drug_doses/$medicine .t.text
      ;button .t.save -command "writeFileEdit $rootdirectory/drug_doses/$medicine .t.text;bell" -text Save
      ;pack .t.save -side bottom
      ;button .t.delete -bg red -fg yellow -text "Del. File"  -command {toplevel .sure
         ;label .sure.question -text "Sure?"
         ;button .sure.yes  -command "file delete $rootdirectory/drug_doses/$medicine;destroy .sure;destroy .t;bell" -text Yes;
         ;button .sure.no -command "destroy .sure" -text No;pack .sure.question .sure.yes .sure.no};

      ;pack .t.delete -side bottom -anchor sw ;button .t.exit -fg red -bg yellow -text Exit -command {destroy .t;bell}
      ;pack .t.exit -side top}
      pack .t2.edit

  }   

proc checkallergies {} {

global medicine
global name
global rootdirectory

set f [open $rootdirectory/allergies/$name r]

set counter 1

while {![eof $f]} {
gets $f line
set allergy($counter) $line   
incr counter   
   
   }

   close $f

foreach {number allergy2} [array get allergy] { 
   if { $allergy2 == $medicine } {


   toplevel .t5

   button .t5.dosewarning -fg yellow -bg red -text {Warning! possible allergy!...}
   pack .t5.dosewarning;wm title .t5 "Allergy alert - $name $medicine"
   button .t5.ok -fg steelblue -bg peachpuff -text IGNORE -command {destroy .t5;bell}
   pack .t5.ok -side bottom
   button .t5.edit -fg steelblue -bg peachpuff -text {Edit/View Allergy File} \
     -command {destroy .t5;bell;toplevel .t ;text .t.text  -wrap word -yscrollcommand ".t.scroll set";pack .t.text -side left;
      scrollbar .t.scroll -command ".t.text yview"
      ;wm title .t $name
      ;pack .t.scroll -side left -fill y;loadFileEdit $rootdirectory/allergies/$name .t.text
      ;button .t.save -command "writeFileEdit $rootdirectory/allergies/$name .t.text;bell" -text Save
      ;pack .t.save -side bottom
      ;button .t.delete -bg red -fg yellow -text "Del. File"  -command {toplevel .sure
         ;label .sure.question -text "Sure?"
         ;button .sure.yes  -command "file delete $rootdirectory/allergies/$name;destroy .sure;destroy .t;bell" -text Yes;
         ;button .sure.no -command "destroy .sure" -text No;pack .sure.question .sure.yes .sure.no};

      ;pack .t.delete -side bottom -anchor sw ;button .t.exit -fg red -bg yellow -text Exit -command {destroy .t;bell}
      ;pack .t.exit -side top}
      pack .t5.edit
      }
      if [winfo exists .t5] { 
      tkwait window .t5
      }
     }
  }


# procedure to check the current medicine variable against a list of potential
# drug interactions that may be in the patient's drug refill file

proc checkInteractions {} {

global medicine
global name
global rootdirectory
global match
catch {set f [open $rootdirectory/drug_interactions/$medicine]}

catch {while {[gets $f line] > 0} {
     set g [open $rootdirectory/drug_refills/$name]
     split $line ":"
          while {[gets $g line2] >= 0} {
               split $line2 " "
               if [regexp [lindex $line 0] [lindex $line2 2]] {
                 
                    set match [lindex $line2 2]
                    toplevel .t3
                    wm title .t3 $medicine
                    button .t3.dosewarning -fg yellow -bg red -text "Warning! possible drug interaction... $medicine - [lindex $line2 2]"
                    pack .t3.dosewarning
                    button .t3.ok -fg steelblue -bg peachpuff -text IGNORE -command {destroy .t3;bell}
                    pack .t3.ok -side bottom
                    button .t3.edit -fg steelblue -bg peachpuff -text "View/Edit Drug Interaction File for $medicine" \
                    -command {destroy .t3;bell;toplevel .t4 ; text .t4.text -wrap word -yscrollcommand ".t4.scroll set";pack .t4.text -side left;
                    scrollbar .t4.scroll -command ".t4.text yview"
                    wm title .t4 $medicine
                    pack .t4.scroll -side left -fill y; loadFileEdit $rootdirectory/drug_interactions/$medicine .t4.text
                    forAllMatches .t4.text $match {.t4.text tag add big first last}   
                    .t4.text tag configure big -background black -foreground yellow  -font -Adobe-Helvetica-Medium-R-Normal--*-240-* 
                    .t4.text see big.last
                    button .t4.save -command "writeFileEdit $rootdirectory/drug_interactions/$medicine .t4.text;bell" -text Save
                    pack .t4.save -side bottom  
                    button .t4.delete -bg red -fg yellow -text "Del. File"  -command {toplevel .sure
                    label .sure.question -text "Sure?"
                    button .sure.yes  -command "file delete $rootdirectory/drug_interactions/$medicine;destroy .sure;destroy .t4;bell" -text Yes;
                    button .sure.no -command "destroy .sure" -text No;pack .sure.question .sure.yes .sure.no}
                    pack .t4.delete -side bottom -anchor sw ;button .t4.exit -fg red -bg yellow -text Exit -command {destroy .t4;bell}
                    pack .t4.exit}
                    pack .t3.edit
                    }
                 if [winfo exists .t3] {
                 tkwait window .t3
                 }
               }
            close $g
            }
          close $f
       }
     }




proc tgrep {pattern file} {

     global dose
     global quantity
     global drugstore
     global initial
     
         set f [open $file r]
         set pat $pattern
         while {[gets $f line] >=0} {
              if [regexp $pat $line] {
                   set dose [lindex $line 3]
                   set quantity [lindex $line 4]
                   set drugstore [lindex $line 5]
                   set initial [lindex $line 6]
                   }
                   }
          close $f
}


proc loadFile {file} { 
     global medicine
     global name
     global nameentry
     global time
     set time [clock format [clock seconds] -format "%x"]
     .text2 delete 1.0 end
     set lineno 1
     set f [open $file]
     while {![eof $f]} {
            #;.text2 insert end [read $f 1000]
            .text2 insert end [gets $f]\n
            .text2 tag add drugcolor "$lineno.15" "$lineno.15 wordend"
            set lineno [expr $lineno +1 ]
            .text2 yview end
     }
   close $f
   .text2 tag configure drugcolor -foreground blue
   .text2 tag bind drugcolor <Double-Button-1> {set medicine [.text2 get "insert wordstart" "insert wordend"] ; tgrep $medicine $rootdirectory/drug_refills/$name ;LoadDoses;checkdruginfo  
;#   .text2 tag bind drugcolor <Button-3> {.text2 insert "insert wordend" Stopped}
   .text2 tag bind drugcolor <Button-3> {set stopmedicine [.text2 get "insert wordstart" "insert wordend"];forAllMatches .text2 $stopmedicine {.text2 insert "last lineend" " Stopped $time"}} 
   .text2 tag add checked "insert wordstart" "insert wordend" ; .text2 tag   configure checked -foreground red ;$nameentry configure -bg grey -fg black }
    }

proc loadFileRefill file {
     global medicine
     global name
     global nameentry
     global Url
     set Url $file
     .text delete 1.0 end
     set lineno 1
     set f [open $file]
     while {![eof $f]} {
            
            .text insert end [gets $f]\n
            .text tag add drugcolor "$lineno.15" "$lineno.15 wordend"
            .text tag add filename "$lineno.end - 5 chars wordstart" "$lineno.end"
            set lineno [expr $lineno +1 ]
            .text2 yview end
     }
   close $f
   .text tag configure drugcolor -foreground blue
   .text tag configure filename -foreground blue
   .text tag bind drugcolor <Double-Button-1> {set medicine [.text get "insert wordstart" "insert wordend"] ; tgrep $medicine $rootdirectory/drug_refills/$name; LoadDoses
   .text tag add checked "insert wordstart" "insert wordend" ; .text tag   configure checked -foreground red ;$nameentry configure -bg grey  -fg black }
   .text tag bind filename <Double-Button-1> {set name [.text get "insert wordstart" "insert wordend"] ; loadFile  $rootdirectory/drug_refills/$name
   .text tag add namechecked "insert wordstart" "insert wordend" ; .text tag configure namechecked -foreground red ; $nameentry configure -bg grey -fg black }

    }

proc loadFileEdit {file window} {
     $window delete 1.0 end
     set lineno 1
     set f [open $file]
     while {![eof $f]} {
     $window insert end [gets $f]\n
     $window yview end
     }
   close $f
}



proc writeFile file {
     set f [.text2 get 1.0 end]
     set f2 [open $file w]
     puts $f2 $f
     close $f2
}


proc writeFileEdit {file window} {
     set f [$window get 1.0 end]
     set f2 [open $file w]
     puts $f2 $f
     close $f2
}


proc forAllMatches {w pattern script} {
     scan [$w index end] %d numLines
     for {set i 1} {$i < $numLines} {incr i} {
        $w mark set last $i.0
        while { [regexp -indices $pattern \
            [$w get last "last lineend"] indices]} {
            $w mark set first \
                    "last + [lindex $indices 0] chars"
            $w mark set last "last + 1 chars \
                    + [lindex $indices 1] chars"
             uplevel $script
         }
     }
  }

# this sends the data in the entry boxes to the temporary files (one for each drugstore ) 
# that holds the information before it is
# faxed to each drugstore
# also creates a file for progress notes, allergies, drug_doses, drug_interactions etc if they don't yet exist

proc test {} {
global name medicine dose quantity drugstore yourname initial note rootdirectory tempfaxdirectory

if [file isfile $rootdirectory/drug_refills/$name] {
     set f [open $rootdirectory/drug_refills/$name a]
     
     
     puts $f "[clock format [clock seconds] -format "%x %R"] $medicine $dose $quantity $drugstore $initial $yourname $note"
  
     
     close $f
   
    
             } else {
                  
                     set f [open $rootdirectory/drug_refills/$name a]
                     
     
                        puts $f "Refill file of - $name"        
                        puts $f "[clock format [clock seconds] -format "%x %R"] $name $medicine $dose $quantity $drugstore $initial $yourname $note"
                       
                     close $f
                  
                   
               }

if [file isfile $tempfaxdirectory/$drugstore] {
   set g [open $tempfaxdirectory/$drugstore a]
     puts $g "[clock format [clock seconds] -format "%x %R"] $name $medicine $dose $quantity $drugstore $initial $yourname \n $note"
   close $g
   } else {
                     set g [open $tempfaxdirectory/$drugstore a]
                    

                        puts $g "                                                                    "
                        puts $g "                                  Tulare Family Practice"
                        puts $g "                                      922 Cherry St."
                        puts $g "                                     Tulare, CA 93274"  
                        puts $g "                             Phone: 559-686-3451 or 559-686-3421"
                        puts $g "                                     Fax: 559-686-0799"
                        puts $g "                                                           "
                        puts $g "RESPONSE TO YOUR PRESCRIPTION REFILL REQUEST: "
                        puts $g "                                              "
                        puts $g "[clock format [clock seconds] -format "%x %R"] $name $medicine $dose $quantity $drugstore $initial $yourname \n $note"
            close $g
}
    
     if ![file isfile $rootdirectory/drug_doses/$medicine] {
         set f [open $rootdirectory/drug_doses/$medicine w]
         close $f
     }

     if ![file isfile $rootdirectory/drug_interactions/$medicine] {
         set f [open $rootdirectory/drug_interactions/$medicine w]
         close $f
         }

     if ![file isfile $rootdirectory/progress_notes/$name.htm] {
         set f [open $rootdirectory/progress_notes/$name.htm w]
            puts $f "<HTML>"
            puts $f "<TITLE>$name.htm</TITLE>"
            puts $f "<BODY>"
            puts $f "<CENTER>"
            puts $f "<H1>$name</H1>"
            puts $f "</CENTER><BR>"
         close $f
         }

     if ![file isfile $rootdirectory/allergies/$name] {
         set f [open $rootdirectory/allergies/$name w]
         puts $f "Allergies -"
         close $f
         }

         set splitname [split $name _ ]

     if ![file isfile $rootdirectory/problem_list/$name] {
         set f [open $rootdirectory/problem_list/$name w]
              puts $f "$name - Problem List and History"
              puts $f "Problems"
              puts $f "Past Medical Illnesses"
              puts $f "Past Surgeries"
              puts $f "Significant past procedures"
              puts $f "Immunizations"
              puts $f "Family History"
              puts $f "Social History" 

         close $f
         }

    if ![file isfile $rootdirectory/demographics/$name] {
        set f [open $rootdirectory/demographics/$name w]
        puts $f "lastname:[lindex $splitname 0]"
        puts $f "firstname:[lindex $splitname 1]"
        puts $f "mi: "
        puts $f "dob: "
        puts $f "streetaddress: "
        puts $f "city: "
        puts $f "zip: "
        puts $f "state: "
        puts $f "homephone: "
        close $f
        }

    if ![file isfile $rootdirectory/drug_information/$medicine.cfm] {
        set f [open $rootdirectory/drug_information/$medicine w]
        puts $f "$medicine - Drug Information"
        close $f
        }
     if ![file isfile $rootdirectory/drugs/$medicine] {
        set f [open $rootdirectory/drugs/$medicine w]
        ;#puts $f "$medicine - synonyms"
        close $f
        }
     if ![file isdirectory $rootdirectory/lab_results/$name] {
       file mkdir $rootdirectory/lab_results/$name
       }


}

# this checks if the patient is registered in the program and prompts you
# to enter the demographic information so it can be included in the prescription.

proc checkNewPatient {} {
global name lastname firstname mi dob streetaddress city zip state homephone rootdirectory
global tcl_platform
;# create a new demographic file for a new patient so the name address dob and phone
;# can be included in the printed prescription. Put the first and last name in the file.

set splitname [split $name _ ] 

  if ![file isfile $rootdirectory/demographics/$name] {
        set f [open $rootdirectory/demographics/$name w]
        puts $f "lastname:[lindex $splitname 0]"
        puts $f "firstname:[lindex $splitname 1]"
        puts $f "mi: "
        puts $f "dob: "
        puts $f "streetaddress: "
        puts $f "city: "
        puts $f "zip: "
        puts $f "state: "
        puts $f "homephone: "
        close $f
        ;# open the file, read the data and send the data to the demographicform.tcl
        if {$tcl_platform(os) == "Linux"} { 
        send demographicform.tcl "clearform"
        } else {
        comm send ${demographicform.tcl} "clearform"
        }
        set f [open $rootdirectory/demographics/$name r]
         while {[gets $f line] >=0} {       
                set line [split $line :]
                set first [lindex $line 0]
                set second [lindex $line 1]
                if {$tcl_platform(os) == "Linux"} {
                send demographicform.tcl "set $first {$second}"
                send demographicform.tcl "set filename $name"
                } else {
                comm send ${demographicform.tcl} "set $first {$second}"
                comm send ${demographicform.tcl} "set filename $name"
                }
                } ;# end of the while {[gets $f line] >=0} statement above
              
                close $f
     
        toplevel .checknewpatient
        message .checknewpatient.message -text "This is a new 
 patient.  Enter 
 address dob and 
 phone no. in the 
 demographic form."
        pack .checknewpatient.message
        button .checknewpatient.ok -text {OK! Done..} -command {destroy .checknewpatient}
        pack .checknewpatient.ok
        focus .checknewpatient
        grab .checknewpatient
        tkwait window .checknewpatient
          if {$tcl_platform(os) == "Linux"} {
          send demographicform.tcl calcage
          send demographicform.tcl {.top17.men21 config -text $healthplan}
          send demographicform.tcl {.top17.men23 config -text $PCP}
          send browsename.tcl ".list delete 0 end;refresh"
          } else {
          comm send ${demographicform.tcl} calcage
          comm send ${demographicform.tcl} {.top17.men21 config -text $healthplan}
          comm send ${demographicform.tcl} {.top17.men23 config -text $PCP}
          comm send ${browsename.tcl} ".list delete 0 end;refresh"
          }
        } ;# end of the if![file isfile $rootdir... statement above

       

}      


proc Log { } {
   global input
   if [eof $input] {
       Stop
     } else {
             gets $input line
             .text insert end $line\n
             .text see end
     }
}

proc Stop { } {
           global input 
           catch {close $input}
}

proc statistics { } {
     global tcl_platform
     global rootdirectory
   if {$tcl_platform(os) == "Linux"} {

     set lineno 1
     
     set counter 0
     foreach patient [exec ls $rootdirectory/drug_refills] {
        incr counter
              }
     .text delete 1.0 end
     .text insert end "Total number of patients is - $counter\n"
     incr lineno     

     set counter 0
     foreach drug [exec ls $rootdirectory/drugs] {
     incr counter
     }
     .text insert end "Total number of drugs is    - $counter\n\n"
    incr lineno 2
    
     .text insert end "Drug Name -      Number of prescriptions\n"
    incr lineno
     
foreach file [exec ls $rootdirectory/drugs] {
set counter 0
puts "counter is $counter"
puts "file is $file"
   foreach file2 [exec ls $rootdirectory/drug_refills] {
       puts "$file"
       puts "$file2"
       puts "$counter"
       set f [open $rootdirectory/drug_refills/$file2 r]


       while {![eof $f]}  {

       gets $f line
       puts "line is $line"
       if [regexp $file $line] {
       incr counter
       puts "$counter"
       }

        ;#  if {[eof $f]} {
        ;#  set drugcount($file) $counter
          
        ;#  .text insert $lineno.0 "                                          \n"
        ;#  .text insert $lineno.0 "$file"
         
        ;#  .text insert $lineno.25 " - $drugcount($file)"
        ;#  };#for the if statement

     };#for the while loop

;#incr counter


close $f
;# after 200
};# end of second or inner foreach loop

         set drugcount($file) $counter
        .text insert $lineno.0 "                                             \n"
        .text insert $lineno.0 "$file"
        .text insert $lineno.25 " - $drugcount($file)"
incr lineno ;# keeps track of which line to insert the current data to.

};# end of first foreach loop



;# end of if statment for LINUX environment
} else {

;# beginning of same stuff for WINDOWS environment
     set lineno 1
     
     set counter 0
     foreach patient [exec command.com /c dir /ON $rootdirectory/drug_refills] {
       
       if [regexp {^[A-Z][a-z]+.+_[A-Z][a-z]+.+$} $patient ] { incr counter }
       ;#incr counter
              }
     .text delete 1.0 end
     .text insert end "Total number of patients is - $counter\n"
     incr lineno     

     set counter 0
     foreach drug [exec command.com /c dir /ON $rootdirectory/drugs] {
       if {$drug == "free"} {continue} else  {  
       if {$drug == "bytes"} {continue} else {
       if {$drug == "in"} {continue} else {
       if {$drug == "drive"} {continue} else {    
       if {$drug == "is"} {continue} else {    
       if {$drug == "of"} {continue} else {
       if {$drug == "return"} {continue} else {
       if {$drug == "to"} {continue} else {
       if {$drug == "has"} {continue} else {
       if {$drug == "no"} {continue} else {
       if {$drug == "label"} {continue} else {

       if [regexp {^[a-z]+$|^[a-z]+\_[a-z]+.+$} $drug ]   { incr counter } 
       ;# incr counter
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
     }
     .text insert end "Total number of drugs is    - $counter\n\n"
     incr lineno 2
    
     .text insert end "Drug Name -      Number of prescriptions\n"
    incr lineno


foreach file [exec command.com /c dir /ON $rootdirectory/drugs] {
if {[file isfile $rootdirectory/drugs/$file] && [regexp {^[a-z]+$|^[a-z]+\_[a-z]+.+$} $file ]}  {
set counter 0
set f [open $rootdirectory/drugs/$file r]
;#puts $file

     while {![eof $f]}  {

     gets $f line
     incr counter
;#     puts $counter

          if {[eof $f]} {
          set drugcount($file) $counter
          
          
          .text insert $lineno.0 "                                          \n"
          .text insert $lineno.0 "$file"
         
          
          .text insert $lineno.25 " - $drugcount($file)"
          };#for the if statement

     };#for the while loop

incr counter

close $f
incr lineno
} ;# end of if [file isfile $file] statment
};# end of foreach loop for Windows environment
     



} ;# end of else statement

} ;# end of proc statistics

proc spinMonth {win step} {
    set months {
        1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50
        51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100
        101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140
        141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180
        181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220
        221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 201 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260
        261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300
        
    }

    set index [expr [lsearch $months [$win get]] + $step]

    if {$index < 0} {set index 299}
    if {$index > 299} {set index 0}

    $win delete 0 end
    $win insert 0 [lindex $months $index]
}

proc checkdruginfo {} {
    global rootdirectory
    global medicine
    if [file isfile $rootdirectory/drug_information/$medicine.cfm] {
    .topframe.toprightframe.toprightleftframe.druginformationbutton config -text "There is drug info" -fg yellow -bg red
    } else { 
    .topframe.toprightframe.toprightleftframe.druginformationbutton config -text "No drug info. avail." -fg black -bg MediumSeaGreen 
    }     
}

proc printRx {} {
global tcl_platform
global rootdirectory
global name
global medicine
global dose
global quantity
global drugstore
global initial
global yourname
global note
set f [open $rootdirectory/demographics/$name r]
              catch { while {[gets $f line] >=0} {
               
                ;#gets $f line
                
                set line [split $line :]
                puts $line
                set first [lindex $line 0]
                set second [lindex $line 1]
                set $first $second
              };# end of while loop
            } ;# end of catch statement 
close $f
set f [open $rootdirectory/drug_programs/tempRxfile w]

puts $f "\n\n\n\n"
puts $f "                          Tulare Family Practice"
puts $f "                               922 Cherry St."
puts $f "                             Tulare, CA. 93274"
puts $f "                             phone:  559-686-3451" 
puts $f "                             fax:  559-688-0799"
puts $f "\n"
puts $f "                           Alexander Caldwell M.D."  
puts $f "                             CA. License - G32424"  
puts $f "                              DEA # - AC7238365"
puts $f "\n\n\n"
puts $f "     [clock format [clock seconds] -format "%x %R"]"
puts $f "     Prescription for: $firstname $mi $lastname  D.O.B. $dob"
puts $f "                       $streetaddress $city $state $zip"
puts $f "                       $homephone"
puts $f "\n\n\n"
puts $f "                                $medicine"
puts $f "\n\n"
puts $f "                                # $quantity"
puts $f "\n\n"
puts $f "                                $dose"
puts $f "\n\n\n\n\n\n"
puts $f "                                Alexander Caldwell M.D."
close $f

;# the next lines appear to be not needed since the other procedures take care of entering the data into the
;# patient's refill file

;#set f [open $rootdirectory/drug_refills/$name a]
;#puts $f "[clock format [clock seconds] -format "%x %R"] $medicine $dose $quantity $drugstore $initial $yourname $note"
;#close $f
;#loadFile $rootdirectory/drug_refills/$name;.text2 yview end


if {$tcl_platform(os) == "Linux"} {
 exec lpr -Praw $rootdirectory/drug_programs/tempRxfile &
} else {
 exec c:/Progra~1/access~1/wordpad.exe /P $rootdirectory/drug_programs/tempRxfile &
}

}

global tempdate
set tempdate [clock format [clock seconds] -format "%d%b%Y"]
;# this is for viewing incoming faxes for lab results
proc checkLabResults {} {


global rootdirectory name tempdate
global tcl_platform
toplevel .faxes
button .faxes.cancel -bg red -fg yellow -text "Cancel/Done" -command {destroy .faxes}
pack .faxes.cancel
entry .faxes.entry -textvariable namefragment
pack .faxes.entry -side top -fill x -expand true
balloonhelp .faxes.entry "Enter part of the \n name here and \n press return \n to search."
bind .faxes.entry <Key-Return> {setselection $namefragment}
listbox .faxes.list1 -yscroll ".faxes.scroll1 set" -relief sunken -width 25 -height 40 \
         -setgrid yes
pack .faxes.list1 -side left -fill both -expand yes

scrollbar .faxes.scroll1 -command ".faxes.list1 yview"
pack  .faxes.scroll1 -side right -fill y
wm title .faxes "$name - Lab Results"
if {$tcl_platform(os) == "Linux"} {
foreach fax [exec ls $rootdirectory/lab_results/$name] {
.faxes.list1 insert end $fax
}
} else {
foreach fax [exec command.com /c dir /ON $rootdirectory/lab_results/$name] {
.faxes.list1 insert end $fax
}
}
bind .faxes.list1 <Double-Button-1> {foreach i [selection get] {
 if {$tcl_platform(os) == "Linux"} {
 exec  $rootdirectory/drug_programs/viewfax $rootdirectory/lab_results/$name/$i &
 } else {
 exec c:/bgfax/view.exe $rootdirectory/lab_results/$name/$i &
 }
 ;#destroy .faxes
}}


bind .faxes.list1 <Double-Button-3> {foreach i [selection get] {
         toplevel .areyousurefaxes
         label .areyousurefaxes.dialog -text "Delete $i ?"
         label .areyousurefaxes.question -text "Sure?"
         button .areyousurefaxes.yes  -command "file delete $rootdirectory/lab_results/$name/$i
         destroy .areyousurefaxes
         refresh  .faxes.list1 $rootdirectory/lab_results/$name
         bell" -text Yes;
         button .areyousurefaxes.no -command "destroy .areyousurefaxes" -text No
         pack .areyousurefaxes.dialog .areyousurefaxes.question .areyousurefaxes.yes .areyousurefaxes.no}
         }



bind .faxes.list1 <Button-2> {foreach i [selection get] {

 ;#tk_getSaveFile -initialdir /var/spool/fax/incoming -initialfile /root/lab_results/$name -parent .faxes -title "Save Lab Results"
  toplevel .savelabdialog
  label .savelabdialog.label1 -text "$name - Lab Results"
   pack .savelabdialog.label1   
   entry .savelabdialog.entry1 -textvariable incomingfile
   pack .savelabdialog.entry1
   set incomingfile $i
   label .savelabdialog.label2 -text "Save Fax as ..."
   pack .savelabdialog.label2
   entry .savelabdialog.entry2 -textvariable savedfile -width 60
   pack .savelabdialog.entry2
 
   set savedfile $rootdirectory/lab_results/$name/$tempdate
   button .savelabdialog.save -text "SAVE" -fg yellow -bg red -command {
   if [file isdirectory $rootdirectory/lab_results/$name] {
   file copy $rootdirectory/lab_results/$name/$i  $savedfile
   } else {
   file mkdir $rootdirectory/lab_results/$name
   file copy $rootdirectory/lab_results/$name/$i $savedfile
   }}
   pack .savelabdialog.save
   button .savelabdialog.cancel -text "CANCEL/DONE" -fg yellow -bg black -command {
   destroy .savelabdialog
   }
   pack .savelabdialog.cancel
}}


}

proc refresh {listbox directory} {
$listbox delete 0 end
foreach i [exec ls $directory] {
$listbox insert end $i
}
}   

proc setselection {namefragment} {

.faxes.list1 see 0 
set index 0
foreach i [.faxes.list1 get 0 end] {
    .faxes.list1 yview $index
    
    if [regexp $namefragment $i] {
    .faxes.list1 selection set $index
    .faxes.list1 activate $index
    break
    }
   incr index
}
}


  # build widget .bottomframe
  frame .bottomframe \
    -borderwidth {2} \
    -cursor {pirate} \
    -relief {raised}

  # build widget .bottomframe.bottomleftframe
  frame .bottomframe.bottomleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .bottomframe.bottomleftframe.bottomleftleftframe
  frame .bottomframe.bottomleftframe.bottomleftleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .bottomframe.bottomleftframe.bottomleftleftframe.tempfilebutton
  button .bottomframe.bottomleftframe.bottomleftleftframe.tempfilebutton \
    -command {test;$nameentry configure -fg yellow -bg red;bell; loadFile $rootdirectory/drug_refills/$name;.text2 yview end;checkdose;checkInteractions;checkallergies
              if {$tcl_platform(os) == "Linux"} {
              send browsename.tcl {.list delete 0 end;refresh}
              send browsedrug.tcl {.list delete 0 end;refresh}
              send browsename.tcl "set selection $name"
              send browsedrug.tcl "set selection $medicine"
              } else {
              comm send ${browsename.tcl} {.list delete 0 end;refresh}
              comm send ${browsedrug.tcl} {.list delete 0 end;refresh}
              comm send ${browsename.tcl} "set selection $name"
              comm send ${browsedrug.tcl} "set selection $medicine"
              }

} \
    -padx {9} \
    -pady {3} \
    -text {1. send data to temp. file-repeat for each refill}

balloonhelp .bottomframe.bottomleftframe.bottomleftleftframe.tempfilebutton "This sends whatever values \n are in the boxes at top \
to a temporary file for \n the currently selected drugstore."

  # build widget .bottomframe.bottomleftframe.bottomleftrightframe
  frame .bottomframe.bottomleftframe.bottomleftrightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .bottomframe.bottomleftframe.bottomleftrightframe.preparefaxbutton

  button .bottomframe.bottomleftframe.bottomleftrightframe.preparefaxbutton \
    -command { if {$tcl_platform(os) == "Linux" } {
              # exec $rootdirectory/drug_programs/]test3.tcl & 
                .text delete 1.0 end
                if [catch {open "|$rootdirectory/drug_programs/test3.tcl $maxdialattempts |& cat"} input] {
                    .text insert end $input\n
                    } else {
                         fileevent $input readable Log 
                         .text insert end "Starting Fax Program...\n"
                          }
               } else {exec $rootdirectory/drug_programs/test3.bat &
               }
} \
    -padx {9} \
    -pady {3} \
    -text {2. Send Faxes to Drugstores}

balloonhelp .bottomframe.bottomleftframe.bottomleftrightframe.preparefaxbutton "This uses the fax program \n to send a fax file \
for each drugstore that \n has a fax in it's \n temporary file."


  # build widget .bottomframe.bottomrightframe
  frame .bottomframe.bottomrightframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .bottomframe.bottomrightframe.bottomrightleftframe
  frame .bottomframe.bottomrightframe.bottomrightleftframe \
    -borderwidth {2} \
    -relief {raised}

  # build widget .bottomframe.bottomrightframe.bottomrightleftframe.faxrunqbutton
  button .bottomframe.bottomrightframe.bottomrightleftframe.faxrunqbutton \
     -command {writeFile $rootdirectory/drug_refills/$name
} \
    -padx {9} \
    -pady {3} \
    -text {3. Store File}
 
balloonhelp  .bottomframe.bottomrightframe.bottomrightleftframe.faxrunqbutton "This will store any \n changes to the file \
in the right text widget."



# build widget .bottomframe.bottomrightframe.bottomrightrightframe
  frame .bottomframe.bottomrightframe.bottomrightrightframe \
    -borderwidth {2} \
    -relief {raised}
global {note_gen.tcl}
  button .bottomframe.bottomrightframe.bottomrightleftframe.printRxbutton \
     -bg blue -fg yellow -text {Print Rx} -command {checkNewPatient;test;checkdose;checkInteractions;checkallergies;printRx
     loadFile $rootdirectory/drug_refills/$name;.text2 yview end
     set medplan [list $medicine $dose No.- $quantity]
     if {$tcl_platform(os) == "Linux"} {
     send note_gen.tcl "lappend plan $medplan"
     } else {
     comm send ${note_gen.tcl} "lappend plan $medplan"
     }
     }
balloonhelp .bottomframe.bottomrightframe.bottomrightleftframe.printRxbutton "This will print a hardcopy Rx
for a patient to take to the
pharmacy. It stores it in his 
file and checks for allergies,
doses and interactions just like
the refill button."

  pack configure .topframe -expand true -fill both
  pack configure .topframe.topleftframe \
    -side left -expand true -fill both
  pack configure .topframe.toprightframe -side left -expand true -fill both

  # pack master .topframe.topleftframe
  pack configure .topframe.topleftframe.topleftleftframe \
    -side left -expand true -fill both
  pack configure .topframe.topleftframe.topleftrightframe -expand true -fill both

  # pack master .topframe.topleftframe.topleftleftframe
  pack configure .topframe.topleftframe.topleftleftframe.namelabel
  pack configure .topframe.topleftframe.topleftleftframe.nameentry
  pack configure .topframe.topleftframe.topleftleftframe.clearbutton
  pack configure .topframe.topleftframe.topleftleftframe.printbutton
  pack configure .topframe.topleftframe.topleftleftframe.allergybutton 



  # pack master .topframe.topleftframe.topleftrightframe
  pack configure .topframe.topleftframe.topleftrightframe.medicinelabel
  pack configure .topframe.topleftframe.topleftrightframe.medicineentry
  pack configure .topframe.topleftframe.topleftrightframe.clearbutton
  pack configure .topframe.topleftframe.topleftrightframe.editfilebutton
  pack configure .topframe.topleftframe.topleftrightframe.interactionbutton 
  # pack master .topframe.toprightframe
  pack configure .topframe.toprightframe.toprightleftframe \
    -side left -expand true -fill both
  pack configure .topframe.toprightframe.toprightrightframe -expand true -fill both

  # pack master .topframe.toprightframe.toprightleftframe
  pack configure .topframe.toprightframe.toprightleftframe.doselabel
  pack configure .topframe.toprightframe.toprightleftframe.doseentry
  pack configure .topframe.toprightframe.toprightleftframe.clearbutton
  pack configure .topframe.toprightframe.toprightleftframe.dosemenubutton
  pack configure .topframe.toprightframe.toprightleftframe.druginformationbutton
#  pack configure .topframe.toprightframe.toprightleftframe.button0

  # pack master .topframe.toprightframe.toprightrightframe
  pack configure .topframe.toprightframe.toprightrightframe.quantitylabel
  pack configure .topframe.toprightframe.toprightrightframe.quantityentry
  .topframe.toprightframe.toprightrightframe.quantityentry insert 0 "0"
  pack configure  .topframe.toprightframe.toprightrightframe.clearbutton
  pack configure .topframe.toprightframe.toprightrightframe.refillmenubutton
  pack configure .topframe.toprightframe.toprightrightframe.problabframe -expand true -fill both
  pack configure .topframe.toprightframe.toprightrightframe.problabframe.problemlistbutton -side left
  pack configure .topframe.toprightframe.toprightrightframe.problabframe.vitalsignbutton -side left
  pack configure .topframe.toprightframe.toprightrightframe.problabframe.labresults -side right 
  
  pack .middleframe -side top -expand true -fill both


pack .middleframe.middleleftframe -in .middleframe -expand true -fill both
pack .statusframe -in .middleframe.middleleftframe -side right  -expand true -fill both
pack configure .middleframe.middlerightframe -in .middleframe.middleleftframe -side right -expand true -fill both

#  pack master .middleframe.middleleftframe
  pack configure .middleframe.middleleftframe.middleleftleftframe \
    -anchor sw \
    -expand 1 \
    -fill both  \
    -side left

  pack configure .middleframe.middleleftframe.middleleftrightframe -expand true -fill both

 
  pack configure .middleframe.middleleftframe.middleleftleftframe.drugstorelabel \
  -ipady 1 \
  -pady 3

  pack configure $d.drugstoreentry ;#-pady 5  
  pack configure $d.drugstoremenubutton ;#-pady 5
  pack configure $d.faxeditbutton ;#-pady 5

  
   

 


  pack configure .middleframe.middleleftframe.middleleftrightframe.doctorlabel \
    -ipady 1 \
    -pady 2
  pack configure $e.doctorentry
  pack configure $e.doctormenubutton
 
  pack configure $e.dialattemptslabel -side left -anchor n -pady 7
  pack configure $e.dialattemptsentry -side left  -anchor n -pady 7
 
  set maxdialattempts 3

  pack configure .middleframe.middlerightframe.middlerightleftframe \
    -side left \
    -expand true \
    -fill both
  pack configure .middleframe.middlerightframe.middlerightrightframe \
    -side left \
    -expand true \
    -fill both
 
  pack configure .middleframe.middlerightframe.middlerightleftframe.yournamelabel \
    -ipady 1 \
    -pady 3
  pack configure $h.employeeentry
  pack configure $h.employeemenubutton
  pack configure $h.statistics
  
  pack configure .middleframe.middlerightframe.middlerightrightframe.notelabel -ipady 1 -pady 3
  pack configure $i.noteentry
  pack configure $i.notemenubutton
  pack configure .middleframe.middlerightframe.middlerightrightframe.checkrefillbutton





pack .statuslabel -in .statusframe -side top -ipady 1 -pady 8
pack .text3 -in .statusframe -side left -expand true -fill both
pack .scroll3 -in .statusframe -side left -expand true -fill y


  pack configure .bottomframe \
    -side left \
    -expand true \
    -fill both
  
  pack configure .bottomframe.bottomleftframe \
    -side left \
    -expand true \
    -fill both 

  pack configure .bottomframe.bottomrightframe \
    -side left \
    -expand true \
    -fill both

  # pack master .bottomframe.bottomleftframe
  pack configure .bottomframe.bottomleftframe.bottomleftleftframe  \
     -side left \
     -expand true \
     -fill both
     
  pack configure .bottomframe.bottomleftframe.bottomleftrightframe \
     -side left \
     -expand true \
     -fill both
     
  # pack master .bottomframe.bottomleftframe.bottomleftleftframe
  pack configure .bottomframe.bottomleftframe.bottomleftleftframe.tempfilebutton \
      -side left \
      -expand true \
      -fill both
    
  # pack master .bottomframe.bottomleftframe.bottomleftrightframe
  pack configure .bottomframe.bottomleftframe.bottomleftrightframe.preparefaxbutton -expand true -fill both

  # pack master .bottomframe.bottomrightframe
  pack configure .bottomframe.bottomrightframe.bottomrightleftframe -expand true -fill both
  pack configure .bottomframe.bottomrightframe.bottomrightrightframe -expand true -fill both

  # pack master .bottomframe.bottomrightframe.bottomrightleftframe
  pack configure .bottomframe.bottomrightframe.bottomrightleftframe.faxrunqbutton -side left -expand true -fill both

#  pack .bottomframe.bottomrightframe.bottomrightrightframe -side right -expand true -fill both
  pack  .bottomframe.bottomrightframe.bottomrightleftframe.printRxbutton -side left -expand true -fill both


# used to update web server documents on Linux
#  exec /usr/local/etc/httpd/htdocs/makeprogressnotes.cgi
#  exec /usr/local/etc/httpd/htdocs/makedrugrefill.html

  # pack master .
#  pack configure .topframe
#  pack configure .middleframe
#  pack configure .bottomframe



global auto_path
global tk_library

# initialize global variables
proc InitGlobals {} {
  global {dose}
  set {dose} {dosage}
  global {drugstore}
  set {drugstore} {Longs}
  global {initial}
  set {initial} {Caldwell}
  global {medicine}
  set {medicine} {antabuse}
  global {menuTearoff}
  set {menuTearoff} {0}
  global {name}
  set {name} {Caldwell_Alexander}
  global {note}
  set {note} {Refill OK per Doctor}
  global {quantity}
  set {quantity} {quantity}
  global {yourname}
  set {yourname} {Cindy}
}
 
#  set {symbolicName(alpicture)} {.middleframe.middleleftframe.middleleftleftframe.alpicturebutton}
  set {symbolicName(bottomframe)} {.bottomframe}
  set {symbolicName(bottomleftframe)} {.bottomframe.bottomleftframe}
  set {symbolicName(bottomleftleftframe)} {.bottomframe.bottomleftframe.bottomleftleftframe}
  set {symbolicName(bottomleftrightframe)} {.bottomframe.bottomleftframe.bottomleftrightframe}
  set {symbolicName(bottomrightframe)} {.bottomframe.bottomrightframe}
  set {symbolicName(bottomrightleftframe)} {.bottomframe.bottomrightframe.bottomrightleftframe}
  set {symbolicName(bottomrightrightframe)} {.bottomframe.bottomrightframe.bottomrightrightframe}
  set {symbolicName(caldwell)} {.middleframe.middleleftframe.middleleftrightframe.caldwell}
  set {symbolicName(cindybutton)} {.middleframe.middlerightframe.middlerightleftframe.cindybutton}
  set {symbolicName(cocobutton)} {.middleframe.middlerightframe.middlerightleftframe.cocobutton}
  set {symbolicName(conniebutton)} {.middleframe.middlerightframe.middlerightleftframe.conniebutton}
  set {symbolicName(doctorlabel)} {.middleframe.middleleftframe.middleleftrightframe.doctorlabel}
  set {symbolicName(doseentry)} {.topframe.toprightframe.toprightleftframe.doseentry}
  set {symbolicName(doselabel)} {.topframe.toprightframe.toprightleftframe.doselabel}
  set {symbolicName(drugselectbutton)} {.topframe.toprightframe.toprightrightframe.drugselectbutton}
  set {symbolicName(drugstorelabel)} {.middleframe.middleleftframe.middleleftleftframe.drugstorelabel}
  set {symbolicName(editfilebutton)} {.topframe.topleftframe.topleftrightframe.editfilebutton}
  set {symbolicName(evans)} {.middleframe.middleleftframe.middleleftrightframe.evans}
  set {symbolicName(faxrunqbutton)} {.bottomframe.bottomrightframe.bottomrightleftframe.faxrunqbutton}
  set {symbolicName(henrybutton)} {.middleframe.middleleftframe.middleleftrightframe.henrybutton}
  set {symbolicName(kambojbutton)} {.middleframe.middleleftframe.middleleftrightframe.kambojbutton}
  set {symbolicName(kingbutton)} {.middleframe.middleleftframe.middleleftrightframe.kingbutton}
  set {symbolicName(kmart)} {.middleframe.middleleftframe.middleleftleftframe.kmart}
  set {symbolicName(longs)} {.middleframe.middleleftframe.middleleftleftframe.longs}
  set {symbolicName(medicineentry)} {.topframe.topleftframe.topleftrightframe.medicineentry}
  set {symbolicName(medicinelabel)} {.topframe.topleftframe.topleftrightframe.medicinelabel}
  set {symbolicName(middleframe)} {.middleframe}
  set {symbolicName(middleleftframe)} {.middleframe.middleleftframe}
  set {symbolicName(middleleftleftframe)} {.middleframe.middleleftframe.middleleftleftframe}
  set {symbolicName(middleleftrightframe)} {.middleframe.middleleftframe.middleleftrightframe}
  set {symbolicName(middlerightframe)} {.middleframe.middlerightframe}
  set {symbolicName(middlerightleftframe)} {.middleframe.middlerightframe.middlerightleftframe}
  set {symbolicName(middlerightrightframe)} {.middleframe.middlerightframe.middlerightrightframe}
  set {symbolicName(monicabutton)} {.middleframe.middlerightframe.middlerightleftframe.monicabutton}
  set {symbolicName(nameentry)} {.topframe.topleftframe.topleftleftframe.nameentry}
  set {symbolicName(namelabel)} {.topframe.topleftframe.topleftleftframe.namelabel}
  set {symbolicName(nameselectbutton)} {.topframe.toprightframe.toprightleftframe.button0}
  set {symbolicName(notebutton)} {.middleframe.middlerightframe.middlerightrightframe.notebutton}
  set {symbolicName(notebutton2)} {.middleframe.middlerightframe.middlerightrightframe.notebutton2}
  set {symbolicName(notelabel)} {.middleframe.middlerightframe.middlerightrightframe.notelabel}
  set {symbolicName(picturebutton)} {.middleframe.middlerightframe.middlerightrightframe.picturebutton}
  set {symbolicName(preparefaxbutton)} {.bottomframe.bottomleftframe.bottomleftrightframe.preparefaxbutton}
  set {symbolicName(printbutton)} {.topframe.topleftframe.topleftleftframe.printbutton}
  set {symbolicName(quantityentry)} {.topframe.toprightframe.toprightrightframe.quantityentry}
  set {symbolicName(quantitylable)} {.topframe.toprightframe.toprightrightframe.quantitylabel}
  set {symbolicName(root)} {.}
  set {symbolicName(tempfilebutton)} {.bottomframe.bottomleftframe.bottomleftleftframe.tempfilebutton}
  set {symbolicName(tfp)} {.middleframe.middleleftframe.middleleftleftframe.tfp}
  set {symbolicName(topframe)} {.topframe}
  set {symbolicName(topleftframe)} {.topframe.topleftframe}
  set {symbolicName(topleftleftframe)} {.topframe.topleftframe.topleftleftframe}
  set {symbolicName(topleftrightframe)} {.topframe.topleftframe.topleftrightframe}
  set {symbolicName(toprightframe)} {.topframe.toprightframe}
  set {symbolicName(toprightleftframe)} {.topframe.toprightframe.toprightleftframe}
  set {symbolicName(toprightrightframe)} {.topframe.toprightframe.toprightrightframe}

  set {symbolicName(yournamelabel)} {.middleframe.middlerightframe.middlerightleftframe.yournamelabel}

}

# load the correct doses into the menu for the dosages

proc LoadDoses {} {
global rootdirectory
global dose 
global medicine

destroy .topframe.toprightframe.toprightleftframe.dosemenubutton.m
menu .topframe.toprightframe.toprightleftframe.dosemenubutton.m 
set counter 1
set f [open $rootdirectory/drug_doses/$medicine r]

    while {[gets $f line] >0} {
          set dosemenuitem($counter) $line
          .topframe.toprightframe.toprightleftframe.dosemenubutton.m add radiobutton -label $dosemenuitem($counter) \
          -variable dosage -value $dosemenuitem($counter) -command {set dose $dosage}
          incr counter
          }
      close $f
}





#loads the data for the drugstore name and phone no. into memory into an array

proc LoadDrugStore {} {
  
      
global storenumber
global rootdirectory 
 
set f [open $rootdirectory/drug_programs/drugstorelist  r]

while {[gets $f line] >0} {


     set line [split $line]


     set storenumber([lindex $line 0]) [lindex $line 1]
     puts "[lindex $line 0] [lindex $line 1]"
     }
  close $f 
}

proc LoadDoctors {} {
 global e
 global h
 global i
 global c
 global refills
 global rootdirectory
 global initial
 global note
 set counter 1
 set f [open $rootdirectory/drug_programs/doctorlist r]
 destroy $e.doctormenubutton.m
 menu $e.doctormenubutton.m
 while {[gets $f line] >0} {
       set doctor($counter) $line
        $e.doctormenubutton.m add radiobutton -label $doctor($counter) \
        -variable initial -value $doctor($counter) \
        -command LoadDoctors


       incr counter 
      }
 close $f
set counter 1
destroy $h.employeemenubutton.m
menu $h.employeemenubutton.m
  set f [open $rootdirectory/drug_programs/employeelist r]
    while {[gets $f line] >0} {
          set employee($counter) $line
          $h.employeemenubutton.m add radiobutton -label $employee($counter) \
           -variable yourname -value $employee($counter)
          incr counter
          }
     close $f
set counter 1
destroy .middleframe.middlerightframe.middlerightrightframe.notemenubutton.m
menu .middleframe.middlerightframe.middlerightrightframe.notemenubutton.m
 set f [open $rootdirectory/drug_programs/messagelist r]
    while {[gets $f line] >0} {
          set message($counter) $line
          .middleframe.middlerightframe.middlerightrightframe.notemenubutton.m add radiobutton -label [subst $message($counter)] \
          -variable note -value [subst $message($counter)]
          incr counter
          }
     close $f
set counter 1
destroy .topframe.toprightframe.toprightrightframe.refillmenubutton.m
menu .topframe.toprightframe.toprightrightframe.refillmenubutton.m
set f [open $rootdirectory/drug_programs/refillnolist r]
    while {[gets $f line] >0} {
          set refillno($counter) $line
          .topframe.toprightframe.toprightrightframe.refillmenubutton.m add radiobutton -label $refillno($counter) \
          -variable refills -value $refillno($counter) -command {set quantity [lindex [split $quantity x] 0];append quantity $refills}
          incr counter
          }
      close $f

}

proc find {} {
global tcl_platform
if {! [winfo exists .findd]} {
    if {$tcl_platform(os) == "Linux"} {
    iwidgets::finddialog .findd -textwidget .text
    } else {
    finddialog .findd -textwidget .text
          };# end of else
   };# end of if winfo
   .findd center .text
   .findd activate
}

proc editFile { file } {
toplevel .allergy ;text .allergy.text -wrap word -yscrollcommand ".allergy.scroll set"
        ;pack .allergy.text -side left -expand true -fill both;
        scrollbar .allergy.scroll -command ".allergy.text yview"
        ;wm title .allergy "Edit $file"
        ;pack .allergy.scroll -side left -fill y;loadFileEdit  $file .allergy.text
        ;button .allergy.save -command "writeFileEdit $file .allergy.text;LoadDrugStore;createmenubuttons;bell" -text Save
        ;pack .allergy.save -side bottom -fill x
         ;button .allergy.delete -bg red -fg yellow -text "Del. File" -command "toplevel .allergysure
         ;label .allergysure.question -text Sure?  
         ;button .allergysure.yes  -command \"file delete $file;destroy .allergysure;destroy .t;bell\" -text Yes;
         ;button .allergysure.no -command {destroy .allergysure} -text No;pack .allergysure.question .allergysure.yes .allergysure.no"
         pack .allergy.delete -side bottom -anchor sw -fill x; button .allergy.exit -fg red -bg yellow -text Exit -command {destroy .allergy;bell};
         pack .allergy.exit -side top -fill x
}





#load drugstore name and fax numbers
LoadDrugStore
#LoadDoctors

# display/remove toplevel windows.
ShowWindow.

# initialize global variables 
InitGlobals
LoadDoctors

source ./panedtst2.tcl
pack .cpd18 -in .middleframe -side left
#loadFile $rootdirectory/drug_refills/Caldwell_Alexander




# create a number of menubuttons equal to the number of drugstores read from the drugstore file
# loop through the array storenumber( ) to get the variable that holds each store's fax no.

proc createmenubuttons {} {        
global storenumber d
catch {destroy $d.drugstoremenubutton.m}
menu $d.drugstoremenubutton.m
   foreach {storename number} [array get storenumber] {

   puts "storename - $storename  number - $number"
   lappend tempstorelist $storename
   # create a button for each store
  # puts "creating button for $storename"
  # $d.drugstoremenubutton.m add radiobutton -label $storename \
  #      -variable drugstore -value $storename

   }
  
        foreach store [lsort $tempstorelist] {
        $d.drugstoremenubutton.m add radiobutton -label $store \
        -variable drugstore -value $store
        }
}

createmenubuttons
catch {source rouser.tcl}
wm iconify .rouser

#this is for windows only it launches the next program in attempt to keep the
#process ids in sequence, unfortunately this doesn't consistently work

if {$tcl_platform(os) != "Linux"} {
tk appname "TFP_drugrefill.tcl [comm self]"
wm title . "TFP_drugrefilll.tcl [comm self]"
exec wish80 c:/progra~1/tcl/bin/drug_programs/demographicform.tcl &
}

proc returnappname {} {
return [tk appname]
}


# eof
#

